/**************************************************************************
***    
*** Copyright (c) 1995-2000 Regents of the University of California,
***               Andrew E. Caldwell, Andrew B. Kahng and Igor L. Markov
***
***  Contact author(s): abk@cs.ucsd.edu, imarkov@umich.edu
***  Original Affiliation:   UCLA, Computer Science Department,
***                          Los Angeles, CA 90095-1596 USA
***
***  Permission is hereby granted, free of charge, to any person obtaining 
***  a copy of this software and associated documentation files (the
***  "Software"), to deal in the Software without restriction, including
***  without limitation 
***  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
***  and/or sell copies of the Software, and to permit persons to whom the 
***  Software is furnished to do so, subject to the following conditions:
***
***  The above copyright notice and this permission notice shall be included
***  in all copies or substantial portions of the Software.
***
*** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*** EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
*** OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
*** IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*** CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
*** OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
*** THE USE OR OTHER DEALINGS IN THE SOFTWARE.
***
***
***************************************************************************/
















#ifndef  _ROW_IRONING_H_
#define _ROW_IRONING_H_

#include <iostream.h>
#include "ABKCommon/verbosity.h"
#include "SmallPlacers/baseSmallPl.h"

class RBPlacement;
class HGraphWDimensions;

struct RowIroningParameters 
{ 
   unsigned numPasses;
   unsigned windowSize;
   unsigned overlap;
   bool twoDim;
   bool mixed;
   bool cluster;
   
   SmallPlParams smplParams;

   Verbosity verb;

   RowIroningParameters()
	: numPasses(1), windowSize(7), overlap(2), twoDim(0), mixed(0), 
          cluster(0), smplParams()
	{}
   RowIroningParameters(int argc, const char *argv[]);
};

ostream& operator<<(ostream&, const RowIroningParameters&);

void ironRows(RBPlacement& rbplace,
              RowIroningParameters params=RowIroningParameters());

//added by sadya to form 2D instances for Rowironing
//allow left-right and right-left traversal
void ironRows2DRL(RBPlacement& rbplace,
		  RowIroningParameters params, bool verticalDir, bool twoDim,
		  bool cluster);
void ironRows2DLR(RBPlacement& rbplace,
		  RowIroningParameters params, bool verticalDir, bool twoDim, 
		  bool cluster);

#endif
